<template>
  <div class="register-box">
    <div class="register-logo">
      <b>PTManagement Trainer Registration</b>
    </div>

    <div class="card" v-if="!partialUser.sub">
      <div class="card-body">
        <p class="login-box-msg">Register with google</p>

        <a href="#" class="btn btn-block btn-primary" @click="loginGoogle">
          <i class="fa fa-google mr-2"></i>
          Register with Google
        </a>
        <p class="mb-0 pt-2">
          <router-link to="/login" class="text-center">Login</router-link>
        </p>
      </div>
      <!-- /.form-box -->
    </div>
    <div class="card" v-if="partialUser.sub">
      <div class="card-body">
        <p class="login-box-msg">Registration form</p>
        <form @submit.prevent="register">
          <div class="form-group has-validation">
            <label for="first-name">First name <small>*</small></label>
            <input
              class="form-control"
              id="first-name"
              type="text"
              v-model="partialUser.name"
              required
            />
            <div class="invalid-feedback">Please choose a username.</div>
          </div>

          <div class="form-group">
            <label for="middle-name">Middle name</label>
            <input
              class="form-control"
              id="middle-name"
              type="text"
              v-model="partialUser.middle_name"
            />
          </div>

          <div class="form-group">
            <label for="given-name">Last name <small>*</small></label>
            <input
              class="form-control"
              id="given-name"
              type="text"
              v-model="partialUser.given_name"
              required
            />
          </div>

          <div class="form-group">
            <label for="dob">Date of birth <small>*</small></label>
            <input
              class="form-control"
              id="dob"
              type="date"
              v-model="partialUser.dob"
              required
            />
          </div>

          <div class="form-group">
            <label for="phone">Phone number <small>*</small></label>
            <input
              class="form-control"
              id="phone"
              type="text"
              v-model="partialUser.phone"
              pattern="\+?\d{7,}"
              required
            />
            <div class="invalid-feedback">At least 7 numbers</div>
          </div>

          <div class="form-group">
            <label for="address">Address <small>*</small></label>
            <input
              class="form-control"
              id="address"
              type="text"
              v-model="partialUser.address"
              required
            />
          </div>

          <div class="form-group">
            <label for="postal-code">Postal code <small>*</small></label>
            <input
              class="form-control"
              id="postal-code"
              type="text"
              v-model="partialUser.postal_code"
              pattern="\d{4}"
              required
            />
          </div>
          <p>Fields with <b>*</b> is required</p>
          <button class="btn btn-secondary" type="submit">Register</button>
        </form>
        <p class="mb-0">
          <router-link to="/login" class="text-center">Login</router-link>
        </p>
      </div>
    </div>
    <!-- /.card -->
  </div>
</template>

<script>
import swal from "sweetalert2";
import auth from "../controllers/auth.controller";
export default {
  name: "Register",
  data: function () {
    return {
      partialUser: {
        name: "",
        middle_name: "",
        given_name: "",
        dob: "",
        phone: "",
        address: "",
        postal_code: "",
      },
    };
  },
  methods: {
    async loginGoogle() {
      try {
        const user = await this.$gAuth.signIn();
        this.partialUser = await (
          await auth.getTokenInfo(user.getAuthResponse().id_token)
        ).data;
        swal.fire({
          icon: "success",
          title: "Google profile retrieved",
          showCloseButton: false,
          showCancelButton: false,
        });
      } catch (e) {
        console.log(e);
        swal.fire({
          icon: "error",
          title: "Oops...",
          text: "Something went wrong! Please try again",
        });
      }
    },
    async register() {
      //TODO: Better validation
      try {
        let body = {
          firstname: this.partialUser.name,
          subject: this.partialUser.sub,
          middleName: this.partialUser.middle_name,
          lastName: this.partialUser.given_name,
          dob: new Date(this.partialUser.dob).toJSON(),
          email: this.partialUser.email,
          phone: this.partialUser.phone,
          address: this.partialUser.address,
          postalCode: this.partialUser.postal_code,
          image: this.partialUser.picture,
        };
        if (!(await auth.isValidZipCode(body.postalCode))) {
          swal.fire({
            icon: "warning",
            title: "invalid zipCode"
          });

          return;
        }
        const resp = await auth.registerTrainer(body);

        if (resp.status === 201) {
          await swal.fire({
            icon: "success",
            title: "Successfully registered!",
            text: "Wait for an admin to confirm",
            timer: 1500,
          });
          this.$router.push({ path: "/login" });
        } else {
          swal.fire({
            icon: "error",
            title: `Oops... Error code: ${resp.status}`,
            text: `🤔 Something went wrong. Reponse: ${resp.data}`,
          });
        }
      } catch (e) {
        if (e.response) {
          if (e.response.status === 409) {
            await swal.fire({
              icon: "info",
              title: "User already exists",
              text: "Please log in via the login page 😀",
              timer: 5500,
            });

            this.$router.push({ path: "/login" });
          } else {
            swal.fire({
              icon: "error",
              title: `Oops... Reponse code: ${e.response.status}`,
              text: `Something went wrong! Error message: ${e.response.data}`,
            });
          }
        } else {
          swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Something went wrong! Please try again",
          });
        }
      }
    },
  },
  created: function () {
    document.body.classList.add("register-page");
  },
  destroyed: function () {
    document.body.classList.remove("register-page");
  },
};
</script>

<style scoped>
</style>
